<?php
/***************************************************************
*  Copyright notice
*
*  (c) 2003-2010 Renzo Lauper (renzo@churchtool.org)
*  All rights reserved
*
*  This script is part of the kOOL project. The kOOL project is
*  free software; you can redistribute it and/or modify
*  it under the terms of the GNU General Public License as published by
*  the Free Software Foundation; either version 2 of the License, or
*  (at your option) any later version.
*
*  The GNU General Public License can be found at
*  http://www.gnu.org/copyleft/gpl.html.
*  A copy is found in the textfile GPL.txt and important notices to the license
*  from the author is found in LICENSE.txt distributed with these scripts.
*
*  kOOL is distributed in the hope that it will be useful,
*  but WITHOUT ANY WARRANTY; without even the implied warranty of
*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*  GNU General Public License for more details.
*
*  This copyright notice MUST APPEAR in all copies of the script!
***************************************************************/

function hook_include_main($type) {
	global $BASE_PATH;

	$r = NULL;
	$hooks = hook_get_by_type($type);

	if(sizeof($hooks) > 0) {
		foreach($hooks as $hook) {
			$file = $BASE_PATH."plugins/$hook/$hook.php";
			if(file_exists($file)) $r[] = $file;
		}
	}

	return $r;
}//hook_include_main()


function hook_include_sm() {
	global $BASE_PATH, $PLUGINS;

	$r = NULL;
	
	foreach($PLUGINS as $plugin) {
		$file = $BASE_PATH."plugins/".$plugin["name"]."/submenu.php";
		if(file_exists($file)) $r[] = $file;
	}
	return $r;
}//hook_include_sm()


function hook_include_ll() {
	global $BASE_PATH, $PLUGINS;

	$r = NULL;
	
	foreach($PLUGINS as $plugin) {
		$file = $BASE_PATH."plugins/".$plugin["name"]."/locallang.php";
		if(file_exists($file)) $r[] = $file;
	}
	return $r;
}//hook_include_ll()


//Erwartet Komma-getrennte Liste der Plugin-Typen und gibt die entsprechenden Include-Datein inkl. Pfad zurck
function hook_get_by_type($type) {
	global $PLUGINS;
	global $BASE_PATH;

	if(!$BASE_PATH) return;

	$types = explode(",", $type);
	//Globale Plugins immer mit einlesen
	$types[] = "global";

	$r = array();
	foreach($PLUGINS as $m) {
	  if($m["name"] && ($type == "_all" || in_array($m["type"], $types)) && file_exists($BASE_PATH."plugins/".$m["name"])) {
	    $temp = $BASE_PATH."plugins/".$m["name"];

			//Dateiname nur gemss BASE_PATH erlauben
			$full_path = realpath($temp);
	    if(substr($full_path, 0, strlen($BASE_PATH."plugins")) != ($BASE_PATH."plugins")) {
				trigger_error("Not allowed Hook-File: ".$temp, E_USER_ERROR);
	      exit;
	    }
			$r[] = $m["name"];
	  }
	}//foreach(PLUGINS)

	return $r;
}//hook_get_by_type()




function hook_action_handler($action) {
	global $PLUGINS;

	$found = FALSE;
	foreach($PLUGINS as $plugin) {
		if($plugin["name"] == substr($action, 0, strlen($plugin["name"]))) $found = TRUE;
	}

	if($found && function_exists("my_action_handler_".$action)) {
    call_user_func("my_action_handler_".$action);
		return TRUE;
  } else { 
	  return FALSE;
	}
}//hook_action_handler()




function hook_action_handler_add($action) {
	global $PLUGINS;

	foreach($PLUGINS as $plugin) {
		$action_ = $plugin["name"]."_".$action;
		if(function_exists("my_action_handler_add_".$action_)) {
			call_user_func("my_action_handler_add_".$action_);
		}
	}
}//hook_action_handler_add()



function hook_action_handler_inline($action) {
	global $PLUGINS;

	foreach($PLUGINS as $plugin) {
		$action_ = $plugin["name"]."_".$action;
		if(function_exists("my_action_handler_inline_".$action_)) {
			call_user_func("my_action_handler_inline_".$action_);
		}
	}
}//hook_action_handler_inline()




function hook_show_case($show) {
	global $PLUGINS;

	$found = FALSE;
	foreach($PLUGINS as $plugin) {
		if($plugin["name"] == substr($show, 0, strlen($plugin["name"]))) $found = TRUE;
	}

	if($found && function_exists("my_show_case_".$show)) {
    call_user_func("my_show_case_".$show);
  }
}//hoock_show_case()



function hook_show_case_add($show) {
	global $PLUGINS;

	foreach($PLUGINS as $plugin) {
		$show_ = $plugin["name"]."_".$show;
		if(function_exists("my_show_case_add_".$show_)) {
			call_user_func("my_show_case_add_".$show_);
		}
	}
}//hook_show_case_add()



function hook_submenu($module, $menu, &$submenu, &$menucounter, &$itemcounter) {
	global $my_submenu;

	if(is_array($my_submenu[$module][$menu])) {
		foreach($my_submenu[$module][$menu] as $s) {
			$pre  = is_array($s['show']) && in_array($_SESSION["show"], $s["show"]) ? "<b>" : "";
			$post = is_array($s['show']) && in_array($_SESSION["show"], $s["show"]) ? "</b>" : "";
			$submenu[$menucounter]["output"][$itemcounter] = $pre.$s["output"].$post;
			$submenu[$menucounter]["link"][$itemcounter] = $s["link"];
			$submenu[$menucounter]["html"][$itemcounter++] = $s["html"];
		}
	}
}//hook_submenu()
?>
