<?php
/***************************************************************
*  Copyright notice
*
*  (c) 2003-2010 Renzo Lauper (renzo@churchtool.org)
*  All rights reserved
*
*  This script is part of the kOOL project. The kOOL project is
*  free software; you can redistribute it and/or modify
*  it under the terms of the GNU General Public License as published by
*  the Free Software Foundation; either version 2 of the License, or
*  (at your option) any later version.
*
*  The GNU General Public License can be found at
*  http://www.gnu.org/copyleft/gpl.html.
*  A copy is found in the textfile GPL.txt and important notices to the license
*  from the author is found in LICENSE.txt distributed with these scripts.
*
*  kOOL is distributed in the hope that it will be useful,
*  but WITHOUT ANY WARRANTY; without even the implied warranty of
*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*  GNU General Public License for more details.
*
*  This copyright notice MUST APPEAR in all copies of the script!
***************************************************************/

if(!in_array($_GET['action'], array('jsongetreservations', 'fcsetdate', 'pdfcalendar', 'fceditres', 'fcdelres'))) {
	//Request session id
	if(!isset($_GET["sesid"])) exit;
	 
	//Start session
	if(FALSE === session_id($_GET["sesid"])) exit;
}
if(FALSE === session_start()) exit;


//Send headers to ensure latin1 charset
header('Content-Type: text/html; charset=ISO-8859-1');

error_reporting(0);
$ko_menu_akt = 'reservation';
$ko_path = "../../";
require($ko_path."inc/ko.inc");
$ko_path = "../";

ko_get_access('reservation');
if($access['reservation']['MAX'] < 1) exit;

// Plugins einlesen:
$hooks = hook_include_main("reservation");
if(sizeof($hooks) > 0) foreach($hooks as $hook) include($hook);

require($BASE_PATH."reservation/inc/reservation.inc");

//Smarty-Templates-Engine laden
require($BASE_PATH."inc/smarty.inc");

//HOOK: Submenus einlesen
$hooks = hook_include_sm();
if(sizeof($hooks) > 0) foreach($hooks as $hook) include($hook);


if(isset($_GET) && isset($_GET["action"])) {
	$action = format_userinput($_GET["action"], "alphanum");
	switch($action) {

		case 'pdfcalendar':
			//No pdf export for day view
			if($_SESSION['cal_view'] == 'agendaDay') {
				print 'daten_pdf_link@@@: not available';
				break;
			}

			//Start pdf
			define('FPDF_FONTPATH',$BASE_PATH.'fpdf/schriften/');
			require($BASE_PATH.'fpdf/fpdf.php');
			$pdf = new FPDF('L', 'mm', 'A4');
			$pdf->Open();
			$pdf->SetAutoPageBreak(true, 10);
			$pdf->SetMargins(5, 5, 5);  //left, top, right
			$pdf->AddFont('arial','','arial.php');
			$pdf->AddFont('arialb','','arialb.php');

			//Set months and filename for year and month view
			if($_SESSION['show'] == 'cal_jahr') {
				for($i=1; $i<=12; $i++) {
					$months[] = $i;
				}
				$filename = getLL('res_filename_pdf').$_SESSION['cal_jahr'].'_'.strftime('%d%m%Y_%H%M%S', time()).'.pdf';
				$add = 4;
			} else if($_SESSION['cal_view'] == 'month') {
				$months[] = $_SESSION['cal_monat'];
				$filename = getLL('res_filename_pdf').str_to_2($_SESSION['cal_monat']).'_'.$_SESSION['cal_jahr'].'_'.strftime('%d%m%Y_%H%M%S', time()).'.pdf';
				$add = 7;
			}
			else if($_SESSION['cal_view'] == 'agendaWeek') {
				$filename = ko_res_cal_woche(strftime('%V', mktime(1,1,1, $_SESSION['cal_monat'], $_SESSION['cal_tag'], $_SESSION['cal_jahr'])), $_SESSION['cal_jahr'], 'pdf');
				$file = $ko_path.'download/pdf/'.$filename;
				$filename = substr($filename, 0, 7+strlen(getLL('res_filename_pdf'))).'.pdf';

				print 'res_pdf_link@@@: <a href="'.$file.'">'.$filename.'</a>';
				break;
			} else break;

			$monthly_title = ko_get_setting('res_monthly_title');
			$show_comment = ko_get_setting("res_pdf_show_comment");
			$show_time = ko_get_setting("res_pdf_show_time");
			foreach($months as $month) {
				$month = str_to_2($month);
				$data = array();

				apply_res_filter($z_where, $z_limit, 'immer', 'immer');
				$startstamp = mktime(1,1,1, (int)$month, 1, $_SESSION['cal_jahr']);
				$endstamp = mktime(1,1,1, ($month == 12 ? 1 : $month+1), 0, ($month == 12 ? $_SESSION['cal_jahr']+1 : $_SESSION['cal_jahr']));
				$z_where .= ' AND `enddatum` >= \''.strftime('%Y-%m-%d', $startstamp).'\' AND `startdatum` <= \''.strftime('%Y-%m-%d', $endstamp).'\'';
				ko_get_reservationen($reservations, $z_where);

				//Calendar weeks
				$kw = array();
				$week_inc = 7*24*60*60;
				$stamp = $startstamp;
				while($stamp < $endstamp+$week_inc) {
					$kw[] = str_to_2(strftime('%V', $stamp));
					$stamp += $week_inc;
				}

				$done_res = array();
				ko_get_resitems($resitems);
				foreach($reservations as $res) {
					$content = array();
					//Create combined reservations for events
					if(ko_get_setting('show_dateres_combined') == 1) {
						//Skip already processed reservations (linked to an event already processed)
						if(in_array($res['id'], $done_res)) continue;
						//Find an event with the current reservation
						ko_get_events($event, 'AND `reservationen` REGEXP \'(^|,)'.$res['id'].'(,|$)\'');
						$event = array_shift($event);
						if($event['id'] && $event['res_combined']) {
							//Mark all linked reservations as done and build purpose text as sum of all items
							$res['zweck'] = '';
							foreach(explode(',', $event['reservationen']) as $resid) {
								if($resid) $done_res[] = $resid;
								ko_get_res_by_id($resid, $thisres_); $thisres = $thisres_[$resid];
								$res['zweck'] .= $resitems[$thisres['item_id']]['name'].', ';
							}
							$res['zweck'] = substr($res['zweck'], 0, -2);
							//Reset color and name according to event group
							$res['item_farbe'] = $event['eventgruppen_farbe'];
							$res['item_name'] = getLL('res_cal_combined').' '.$event['eventgruppen_name'];
							$res['_combined'] = $event['eventgruppen_id'];
						}
					}//if(res_combined)

					//Set title according to setting
					//Set title according to setting
					if($show_comment) {
						$content['text'] = $res['item_name'];
						$content['kommentar'] = $res['zweck'];
					} else {
						if($monthly_title == 'zweck') {
							$content['text'] = $res['zweck'] ? $res['zweck'] : $res['item_name'];
						} else if($monthly_title == 'name') {
							$content['text'] = $res['name'] ? $res['name'] : $res['item_name'];
						} else {
							$content['text'] = $res['item_name'];
						}
					}

					//color
					$content['farbe'] = $res['item_farbe'];

					//Time
					if($show_time) {
						if($res['startzeit'] == '00:00:00' && $res['endzeit'] == '00:00:00') {
							$content['zeit'] = getLL('time_all_day');
						} else {
							if($show_time == 1) {  //Only show start time
								$content['zeit'] = substr($res['startzeit'], 3, 2) == '00' ? substr($res['startzeit'], 0, 2) : substr($res['startzeit'], 0, -3);
							} else if($show_time == 2) {  //Show start and end time
								$content['zeit']  = substr($res['startzeit'], 3, 2) == '00' ? substr($res['startzeit'], 0, 2) : substr($res['startzeit'], 0, -3);
								$content['zeit'] .= '-';
								$content['zeit'] .= substr($res['endzeit'], 3, 2) == '00' ? substr($res['endzeit'], 0, 2) : substr($res['endzeit'], 0, -3);
							}
						}
					} else {
						$content['zeit'] = '';
					}

					//Multiday reservations
					if($res['startdatum'] != $res['enddatum']) {
						$date = $res['startdatum'];
						while((int)str_replace('-', '', $date) <= (int)str_replace('-', '', $res['enddatum'])) {
							if(substr($date, 5, 2) == $month) {
								$data[(int)substr($date, -2)]['inhalt'][] = $content;
							}
							$date = add2date($date, 'tag', 1, TRUE);
						}
					} else {
						$data[(int)substr($res['startdatum'], -2)]['inhalt'][] = $content;
					}
				}//foreach(res)

				ko_export_cal_one_month($pdf, $month, $_SESSION['cal_jahr'], $kw, $data, getLL('res_reservations'), $show_comment);
			}//foreach(months)

			$file = $BASE_PATH.'download/pdf/'.$filename;
			$ret = $pdf->Output($file);
			$filename2 = substr($filename, 0, strlen(getLL('res_filename_pdf'))+$add).'.pdf';  //Fr Link-Text Erstellungszeit entfernen

			print 'res_pdf_link@@@: <a href="'.$ko_path.'download/pdf/'.$filename.'">'.$filename2.'</a>';
		break;


		case "setsortres":
			$_SESSION["sort_item"] = format_userinput($_GET["sort"], "alphanum+", TRUE, 30);
			$_SESSION["sort_item_order"] = format_userinput($_GET["sort_order"], "alpha", TRUE, 4);

			//Mode
			if($_SESSION["show"] == "show_mod_res") $mode = "mod";
			else $mode = "res";

			print "main_content@@@";
			print ko_show_res_liste($mode, FALSE);
		break;



		case "setsortresgroups":
			$_SESSION["sort_group"] = format_userinput($_GET["sort"], "alphanum+", TRUE, 30);
			$_SESSION["sort_group_order"] = format_userinput($_GET["sort_order"], "alpha", TRUE, 4);

			print "main_content@@@";
			print ko_show_items_liste(FALSE);
		break;


		case "setjahr":
			$_SESSION["cal_jahr_jahr"] = format_userinput($_GET["set_year"], "uint", TRUE, 4);
			$_SESSION["cal_jahr_start"] = format_userinput($_GET["set_start"], "uint", TRUE, 2);
			$num = (int)ko_get_userpref($_SESSION["ses_userid"], "cal_jahr_num");
			if($num == 0) $num = 6;  //Default

			print "main_content@@@";
			print ko_res_cal_jahr($num, $_SESSION["cal_jahr_start"], "html", FALSE);
		break;


		case "setstart":
			//Start fr Listenansicht setzen
			if(FALSE === ($_SESSION["show_start"] = format_userinput($_GET["set_start"], "uint"))) {
    	  $_SESSION["show_start"] = 1;
	    }

			print "main_content@@@";
			if($_SESSION["show"] == "liste") {
				print ko_show_res_liste("res", FALSE);
			} else if($_SESSION["show"] == "show_mod_res") {
				print ko_show_res_liste("mod", FALSE);
			} else if($_SESSION["show"] == "list_items") {
				print ko_show_items_liste("all", FALSE);
			}
		break;


		case "itemlist":
		case "itemlistgroup":
			//ID and state of the clicked field
			$id = format_userinput($_GET["id"], "js");
			$state = $_GET["state"] == "true" ? "checked" : "";

			//A single res object was selected
			if($action == "itemlist") {
				if($state == "checked") {  //Select it
					if(!in_array($id, $_SESSION["show_items"])) $_SESSION["show_items"][] = $id;
				} else {  //deselect it
					if(in_array($id, $_SESSION["show_items"])) $_SESSION["show_items"] = array_diff($_SESSION["show_items"], array($id));
				}
			}
			//Resgroup selected or unselected
			else if($action == "itemlistgroup") {
				if($access['reservation']['grp'.$id] < 1) continue;

				//Get all items for this group
				ko_get_resitems_by_group($id, $items);
				foreach($items as $iid => $item) {
					if($state == "checked") {  //Select it
						if(!in_array($iid, $_SESSION["show_items"])) $_SESSION["show_items"][] = $iid;
					} else {  //Deselect it
						if(in_array($iid, $_SESSION["show_items"])) $_SESSION["show_items"] = array_diff($_SESSION["show_items"], array($iid));
					}
				}//foreach(items)
			}//itemlistgroup

			//Save userpref
			sort($_SESSION['show_items']);
			ko_save_userpref($_SESSION['ses_userid'], 'show_res_items', implode(',', $_SESSION['show_items']));

			if($_SESSION['show'] == 'liste') {
				print 'main_content@@@';
				ko_show_res_liste('res', FALSE);
			} else if($_SESSION['show'] == 'cal_jahr') {
				print 'main_content@@@';
				$num = (int)ko_get_userpref($_SESSION['ses_userid'], 'cal_jahr_num');
				if($num == 0) $num = 6;
				ko_res_cal_jahr($num, $_SESSION['cal_jahr_start'], FALSE);
			}

			//Find position of submenu for redraw
			if($action == 'itemlistgroup') {
				if(in_array('itemlist_objekte', explode(',', $_SESSION['submenu_left']))) $pos = 'left';
				else $pos = 'right';
				if(in_array($_SESSION['show'], array('liste', 'cal_jahr'))) print '@@@';
				print submenu_reservation('itemlist_objekte', $pos, 'open', 2);
			}
		break;


		case "itemlisttogglegroup":
			//ID and state of the clicked field
			$id = format_userinput($_GET["id"], "js");
			if(isset($_SESSION["res_group_states"][$id])) {
				$_SESSION["res_group_states"][$id] = $_SESSION["res_group_states"][$id] ? 0 : 1;
			} else {
				$_SESSION["res_group_states"][$id] = ($_GET["state"] == 1 ? 0 : 1);
			}

			//Don't redraw the submenu, as this is done in JS so the list doesn't scroll of the mouse's position
		break;


		case "itemlistsave":
			//Find position of submenu for redraw
			if(in_array("itemlist_objekte", explode(",", $_SESSION["submenu_left"]))) $pos = "left";
			else $pos = "right";

			//save new value
			if($_GET["name"] == "") continue;
			$new_value = implode(",", $_SESSION["show_items"]);
			$user_id = $access['reservation']['MAX'] > 3 && $_GET['global'] == 'true' ? '-1' : $_SESSION['ses_userid'];
			ko_save_userpref($user_id, format_userinput($_GET["name"], "js", FALSE, 0, array("allquotes")), $new_value, "res_itemset");

			print submenu_reservation("itemlist_objekte", $pos, "open", 2);
		break;


		case "itemlistopen":
			//Find position of submenu for redraw
			if(in_array("itemlist_objekte", explode(",", $_SESSION["submenu_left"]))) $pos = "left";
			else $pos = "right";

			//save new value
			$name = format_userinput($_GET['name'], 'js', FALSE, 0, array(), '@');
			if($name == "") continue;

			if(substr($name, 0, 3) == '@G@') $value = ko_get_userpref('-1', substr($name, 3), 'res_itemset');
			else $value = ko_get_userpref($_SESSION['ses_userid'], $name, 'res_itemset');
			$_SESSION["show_items"] = explode(",", $value[0]["value"]);
			ko_save_userpref($_SESSION["ses_userid"], "show_res_items", $value[0]["value"]);

			print submenu_reservation("itemlist_objekte", $pos, "open", 2);
			if($_SESSION['show'] == 'liste') {
				print "@@@main_content@@@";
				ko_show_res_liste("res", FALSE);
			} else if($_SESSION['show'] == 'cal_jahr') {
				print "@@@main_content@@@";
				ko_res_cal_jahr($num, $_SESSION['cal_jahr_start'], FALSE);
			}
		break;


		case "itemlistdelete":
			//Find position of submenu for redraw
			if(in_array("itemlist_objekte", explode(",", $_SESSION["submenu_left"]))) $pos = "left";
			else $pos = "right";

			//save new value
			$name = format_userinput($_GET['name'], 'js', FALSE, 0, array(), '@');
			if($name == "") continue;

			if(substr($name, 0, 3) == '@G@') {
				if($access['reservation']['MAX'] > 3) ko_delete_userpref('-1', substr($name, 3), 'res_itemset');
			} else ko_delete_userpref($_SESSION['ses_userid'], $name, 'res_itemset');

			print submenu_reservation("itemlist_objekte", $pos, "open", 2);
		break;



		case "resgroupselect":
			if($access['reservation']['MAX'] < 2) continue;

			//GET data
			$gid = format_userinput($_GET["gid"], "uint", FALSE, 11, array(), "-");
			$element = format_userinput($_GET["element"], "text");

			$values = array();
			if($gid == "-") {
				$groups = db_select_data("ko_resgruppen", "WHERE 1=1", "*", "ORDER BY `name` ASC");
				foreach($groups as $gid => $group) {
					if($access['reservation']['grp'.$gid] < 2) continue;
					$values[] = "i".$gid.",".$group["name"]."-->";
				}
			} else {
				//Add up link
				$values[] = "i-,".str_replace(",", "", getLL("form_peopleselect_up"));
				//get resitems
				$items = db_select_data("ko_resitem", "WHERE `gruppen_id` = '$gid'", "*", "ORDER BY `name` ASC");
				foreach($items as $iid => $item) {
					$values[] = $iid.",".$item["name"];
				}
			}
			$value = implode("#", $values);

			print "$element@@@$value";
		break;  //peopleselect


		case 'jsongetreservations':
			$data = array();
			$monthly_title = ko_get_setting('res_monthly_title');
			$title_length = ko_get_setting('res_title_length');
			$daten_title_length = ko_get_setting('daten_title_length');
			$show_persondata = ($_SESSION["ses_userid"] != ko_get_guest_id() || ko_get_setting("res_show_persondata"));

			for($i=0; $i<2; $i++) {
				if($i == 1 && $access['reservation']['MAX'] < 2) continue;

				//Get all events
				if($i==0) {
					apply_res_filter($z_where, $z_limit, 'immer', 'immer');
					$z_where .= ' AND `enddatum` >= \''.strftime('%Y-%m-%d', (int)$_GET['start']).'\' AND `startdatum` <= \''.strftime('%Y-%m-%d', (int)$_GET['end']).'\'';
					ko_get_reservationen($reservations, $z_where, '', 'res', 'ORDER BY startdatum,startzeit,item_name ASC');
				} else {
					if($_SESSION['ses_userid'] != ko_get_guest_id()) $mod_where = $access['reservation']['MAX'] > 3 ? ' AND 1=1' : ' AND user_id = \''.$_SESSION['ses_userid'].'\' ';
					else $mod_where = ' AND 1=2 ';
					ko_get_reservationen($reservations, $mod_where, '', 'mod', 'ORDER BY startdatum,startzeit,item_name ASC');
				}

				$done_res = array();
				ko_get_resitems($resitems);
				foreach($reservations as $res) {
					//Only show allowed moderations
					if($i == 1 && ($access['reservation'][$res['item_id']] < 3 && $res['user_id'] != $_SESSION['ses_userid']) ) continue;

					//Create combined reservations for events
					if($i==0 && ko_get_setting('show_dateres_combined') == 1) {
						//Skip already processed reservations (linked to an event already processed)
						if(in_array($res['id'], $done_res)) continue;
						//Find an event with the current reservation
						ko_get_events($event, 'AND `reservationen` REGEXP \'(^|,)'.$res['id'].'(,|$)\'');
						$event = array_shift($event);
						if($event['id'] && $event['res_combined']) {
							//Mark all linked reservations as done and build purpose text as sum of all items
							$event_items = '';
							foreach(explode(',', $event['reservationen']) as $resid) {
								if($resid) $done_res[] = $resid;
								ko_get_res_by_id($resid, $thisres_); $thisres = $thisres_[$resid];
								$event_items .= $resitems[$thisres['item_id']]['name'].', ';
							}
							$event_items = substr($event_items, 0, -2);
							//Reset color and name according to event group
							$res['item_farbe'] = $event['eventgruppen_farbe'];
							if($event['kommentar']) {
								$res['zweck'] = substr($event['kommentar'], 0, $daten_title_length).' ('.$event['eventgruppen_name'].')';
								$res['item_name'] = $event_items;
							} else {
								$res['zweck'] = getLL('res_cal_combined').' '.$event['eventgruppen_name'];
								$res['item_name'] = $event_items;
							}
							$res['_combined'] = $event['eventgruppen_id'];
						}
					}//if(res_combined)



					//Set title according to setting
					switch($monthly_title) {
						case 'name':
							$title = $res['name'] ? $res['name'] : $res['item_name'];
						break;
						case 'zweck':
							$title = $res['zweck'] ? $res['zweck'] : $res['item_name'];
						break;
						default:
							$title = $res['item_name'];
					}
					if(strlen($title) > $title_length) $title = substr($title, 0, $title_length).'..';

					//Format time for tooltip
					if($res['startzeit'] == '00:00:00' && $res['endzeit'] == '00:00:00') $time = getLL('time_all_day');
					else $time = substr($res['startzeit'], 0, -3).' - '.substr($res['endzeit'], 0, -3);

					$tooltip = '';

					//Moderated events
					if($i == 1) {
						if(!ko_res_check_double($res['item_id'], sql2datum($res['startdatum']), sql2datum($res['enddatum']), substr($res['startzeit'], 0, -3), substr($res['endzeit'], 0, -3), $double_error)) {
							$title = '! '.$title.' !';
							$tooltip .= '<b>'.utf8_encode(getLL('res_collision_text')).'</b><br />'.utf8_encode($double_error).'<br /><br />';
							$checkLink = FALSE;
						} else {
							$tooltip .= '<b>'.utf8_encode(getLL('res_mod_open')).'</b><br /><br />';
							$checkLink = TRUE;
						}

					}

					//Tooltip-Text
					$tooltip .= $res['item_name'].'<br />';
					$tooltip .= '<b>'.strftime($DATETIME['ddmy'], strtotime($res['startdatum']));
					if($res['startdatum'] != $res['enddatum']) $tooltip .= ' - '.strftime($DATETIME['ddmy'], strtotime($res['enddatum']));
					$tooltip .= '</b><br />';
					$tooltip .= getLL('res_time').': '.$time.'<br />';
					$tooltip .= '<b>'.$res['zweck'].'</b><br />';
					$tooltip .= $show_persondata ? '<br />'.getLL('res_info_user').': '.$res['name'].'<br />'.$res['email'] : '';

					//Add user who entered the moderation request
					if($i == 1) {
						if($res['user_id']) {
							ko_get_login($res['user_id'], $login);
							if($login['leute_id']) {
								ko_get_person_by_id($login['leute_id'], $person);
								$tooltip .= '<br /><br />'.utf8_encode(getLL('by')).': '.$person['vorname'].' '.$person['nachname'].' ('.$login['login'].')<br />';
							} else {
								$tooltip .= '<br /><br />'.utf8_encode(getLL('by')).': '.$login['login'].'<br />';
							}
						}
						$tooltip .= '<br />';
					}

					//Add editIcons according to access rights
					$editable = FALSE;
					if($i == 0) {
						if(!$res['_combined'] && ($access['reservation'][$res['item_id']] > 2 || ($_SESSION['ses_userid'] == $res['user_id'] && $_SESSION['ses_userid'] != ko_get_guest_id() && $access['reservation'][$res['item_id']] > 1))) {
							$editable = TRUE;
							$delLink  = 'c=confirm(\''.utf8_encode(getLL('res_delete_res_confirm')).'\');if(!c) return false;';
							if($res['serie_id']) $delLink .= 'c2=confirm(\''.utf8_encode(getLL('res_delete_serie_confirm')).'\');';
							else $delLink .= 'c2=false;';
							$delLink .= 'sendReq(\'inc/ajax.php\', \'action,id,serie\', \'fcdelres,'.$res['id'].',\'+c2);';
							if($res['serie_id']) $delLink .= '$(\'#ko_calendar\').fullCalendar(\'refetchEvents\'); tooltip.hide(); return false;';
							else $delLink .= '$(\'#ko_calendar\').fullCalendar(\'removeEvents\', \''.$res['id'].'\'); tooltip.hide(); return false;';
							$deleteIcon = '<input type="image" src="../images/icon_trash.png" onclick="'.$delLink.'" title="'.utf8_encode(getLL('res_delete_res')).'" />';
							$editIcons = $deleteIcon;
						} else {
							$editIcons = '';
						}
					}
					//Add links to approve or delete a moderation
					else {
						if($checkLink) {
							$checkIcon = '<input type="image" src="../images/button_check.png" title="'.utf8_encode(getLL('res_mod_confirm')).'" onclick="c1=confirm(\''.utf8_encode(getLL('res_mod_confirm_confirm')).'\');if(!c1) return false; c=confirm(\''.utf8_encode(getLL('res_mod_confirm_confirm2')).'\');set_hidden_value(\'id\', \''.$res['id'].'\');set_hidden_value(\'mod_confirm\', c);set_action(\'res_mod_approve\');" />';
						} else {
							$checkIcon = '';
						}
						$delLink  = 'c1=confirm(\''.utf8_encode(getLL('res_mod_decline_confirm')).'\');if(!c1) return false;';
						if($access['reservation'][$res['item_id']] > 3) $delLink .= 'c=confirm(\''.utf8_encode(getLL('res_mod_decline_confirm2')).'\');set_hidden_value(\'mod_confirm\', c);';
						$delLink .= 'set_hidden_value(\'id\', \''.$res['id'].'\');set_action(\'res_mod_delete\');';
						$delIcon  = '<input type="image" src="../images/icon_trash.png" title="'.utf8_encode(getLL('res_mod_decline')).'" onclick="'.$delLink.'" />';
						$editIcons = $checkIcon.'&nbsp;'.$delIcon;
					}

					//Build data array for fullCalendar
					$data[] = array('id' => $res['id'],
						'start' => $res['startdatum'].'T'.$res['startzeit'],
						'end' => $res['enddatum'].'T'.$res['endzeit'],
						'title' => utf8_encode($title),
						'allDay' => $res['startzeit'] == '00:00:00' && $res['endzeit'] == '00:00:00',
						'url' => $editable ? 'index.php?action=edit_res&id='.$res['id'] : '',
						'editable' => $editable,
						'className' => ($res['_combined'] ? 'eg'.$res['_combined'] : 'item'.$res['item_id']).($i==1?' fc-modEvent':''),
						'kOOL_tooltip' => utf8_encode($tooltip),
						'kOOL_editIcons' => $editIcons,
					);
				}
			}
			print json_encode($data);
		break;


		case 'fcdelres':
			$id = format_userinput($_GET['id'], 'uint');
			if(!$id) continue;
			$serie = ($_GET['serie'] == 'true');

			do_del_res($id, $serie);
		break;


		case 'fceditres':
			$id = format_userinput($_GET['id'], 'uint');
			$mode = format_userinput($_GET['mode'], 'alpha');
			$dayDelta = format_userinput($_GET['dayDelta'], 'int');
			$minuteDelta = format_userinput($_GET['minuteDelta'], 'int');

			ko_get_res_by_id($id, $res_);
			$res = $res_[$id];
			$new = $res;
			if($dayDelta != 0) {
				if($mode == 'drop') $new['startdatum'] = add2date($res['startdatum'], 'tag', $dayDelta, TRUE);
				$new['enddatum'] = add2date($res['enddatum'], 'tag', $dayDelta, TRUE);
			}
			if($minuteDelta != 0) {
				if($mode == 'drop') {
					$new['startzeit'] = add2time($res['startzeit'], $minuteDelta);
				}
				$new['endzeit'] = add2time($res['endzeit'], $minuteDelta);
			}
			//Check for drop on allDay (minuteDelta and dayDelta 0)
			if($minuteDelta == 0 && $dayDelta == 0) {
				$new['startzeit'] = $new['endzeit'] = '00:00';
			}

			if(FALSE === ko_res_check_double($new['item_id'], $new['startdatum'], $new['enddatum'], $new['startzeit'], $new['endzeit'], $double_error_txt, $id)) {		
				print FALSE;
			} else {
				db_update_data('ko_reservation', 'WHERE `id` = \''.$id.'\'', $new);
				ko_log_diff('edit_res', $new, $res);

				print TRUE;
			}
		break;


		case 'fcsetdate':
			if($_GET['ymd']) {
				list($y, $m, $d) = explode('-', $_GET['ymd']);
				if($d) $_SESSION['cal_tag'] = intval($d);
				if($m) $_SESSION['cal_monat'] = intval($m);
				if($y) $_SESSION['cal_jahr'] = intval($y);
			}
			if($_GET['view']) $_SESSION['cal_view'] = format_userinput($_GET['view'], 'alpha');

			//Redraw mwselect box
			$sel = ko_calendar_mwselect($_SESSION['cal_view']);
			print 'mwselect@@@'.$sel;
		break;


	}//switch(action);
}//if(GET[action])
?>
