<?php
/***************************************************************
*  Copyright notice
*
*  (c) 2003-2010 Renzo Lauper (renzo@churchtool.org)
*  All rights reserved
*
*  This script is part of the kOOL project. The kOOL project is
*  free software; you can redistribute it and/or modify
*  it under the terms of the GNU General Public License as published by
*  the Free Software Foundation; either version 2 of the License, or
*  (at your option) any later version.
*
*  The GNU General Public License can be found at
*  http://www.gnu.org/copyleft/gpl.html.
*  A copy is found in the textfile GPL.txt and important notices to the license
*  from the author is found in LICENSE.txt distributed with these scripts.
*
*  kOOL is distributed in the hope that it will be useful,
*  but WITHOUT ANY WARRANTY; without even the implied warranty of
*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*  GNU General Public License for more details.
*
*  This copyright notice MUST APPEAR in all copies of the script!
***************************************************************/

$ko_path = "../";
$ko_menu_akt = "ical";

include($ko_path."inc/ko.inc");
include($ko_path."reservation/inc/reservation.inc");


$auth = FALSE;
if(!isset($_GET["ko_guest"])) {
	if (!isset($_SERVER['PHP_AUTH_USER'])) {
		header("WWW-Authenticate: Basic realm=\"kOOL\"");
		header("HTTP/1.0 401 Unauthorized");
	} else {
		$user = format_userinput($_SERVER["PHP_AUTH_USER"], "text", TRUE, 32);
		$pw = md5($_SERVER["PHP_AUTH_PW"]);
		$result = mysql_query("SELECT id,login FROM ko_admin WHERE `login` = '$user' AND `password` = '$pw'");
		if(mysql_num_rows($result) == 1) {
			$row = mysql_fetch_assoc($result);
			if($row["login"] == $user) {
				$auth = TRUE;
				$_SESSION["ses_username"] = $row["login"];
				$_SESSION["ses_userid"]   = $row["id"];
			}
		}
	}
}
if(!$auth) {
	//header("HTTP/1.0 404 Not Found");
	//exit;
	$_SESSION["ses_username"] = "ko_guest";
	$_SESSION["ses_userid"] = ko_get_guest_id();
}


if(!ko_module_installed("reservation")) {
	header("HTTP/1.0 404 Not Found");
}
//Get access rights
ko_get_access('reservation');

//get itemset named "ical" if there is one (but not for ko_gueset)
$use_itemset = FALSE;
if($_SESSION["ses_username"] != "ko_guest") {
	$itemsets = ko_get_userpref($_SESSION["ses_userid"], "", "res_itemset");
	foreach($itemsets as $itemset) {
		if(strtolower($itemset["key"]) == "ical") {
			$use_itemset = explode(",", $itemset["value"]);
		}
	}
}

//get all Res items
ko_get_resitems($resitems);
$use_items = array();
foreach($resitems as $item) {
	if($use_itemset) {
		if(in_array($item['id'], $use_itemset) && ($access['reservation']['ALL'] > 0 || $access['reservation'][$item['id']] > 0)) $use_items[] = $item['id'];
	} else {
		if($access['reservation']['ALL'] > 0 || $access['reservation'][$item['id']] > 0) $use_items[] = $item['id'];
	}
}
//apply filter
$z_where = "";
$perm_filter_start = ko_get_setting("res_perm_filter_start");
$perm_filter_ende  = ko_get_setting("res_perm_filter_ende");
if($access['reservation']['MAX'] > 2 && ($perm_filter_start || $perm_filter_ende)) {
	if($perm_filter_start != "") $z_where .= " AND r.startdatum >= '".$perm_filter_start."' ";
	if($perm_filter_ende != "") $z_where .= " AND r.startdatum <= '".$perm_filter_ende."' ";
}
$z_where .= " AND r.startdatum >= '".date('Y-m-d')."' ";
$z_where .= " AND r.item_id IN ('".implode("','", $use_items)."') ";

//get reservations
ko_get_reservationen($res, $z_where);

//build ical file in a string
$ical  = "BEGIN:VCALENDAR\r\n";
$ical .= "VERSION:2.0\r\n";
$ical .= "CALSCALE:GREGORIAN\r\n";
$ical .= "METHOD:PUBLISH\r\n";
$ical .= "PRODID:-//".str_replace("/", "", $HTML_TITLE)."//www.churchtool.org//DE\r\n";
foreach($res as $r) {
	//build ics string
	$ical .= "BEGIN:VEVENT\r\n";
	$ical .= "CREATED:".strftime("%Y%m%dT%H%M%S", strtotime($r["cdate"]))."\r\n";
	$ical .= "LAST-MODIFIED:".strftime("%Y%m%dT%H%M%S", strtotime($r["last_change"]))."\r\n";
	$ical .= "DTSTAMP:".strftime("%Y%m%dT%H%M%S", time())."\r\n";
	$base_url = $_SERVER['SERVER_NAME'] ? $_SERVER['SERVER_NAME'] : $BASE_URL;
	$ical .= 'UID:r'.$r['id'].'@'.$base_url."\r\n";
	if($r["startzeit"] == "00:00:00" && $r["endzeit"] == "00:00:00") {  //daily event
		$ical .= "DTSTART:".strftime("%Y%m%d", strtotime($r["startdatum"]))."\r\n";
		$ical .= "DTEND:".strftime("%Y%m%d", strtotime(add2date($r["enddatum"], "tag", 1, TRUE)))."\r\n";
	} else if($r['startzeit'] != '00:00:00' && $r['endzeit'] == '00:00:00') {  //No end time given so set it to midnight
    $ical .= 'DTSTART:'.date_convert_timezone(($r['startdatum'].' '.$r['startzeit']), 'UTC')."\r\n";
    $ical .= 'DTEND:'.date_convert_timezone(($r['enddatum'].' 23:59:00'), 'UTC')."\r\n";
	} else {
		$ical .= 'DTSTART:'.date_convert_timezone(($r['startdatum'].' '.$r['startzeit']), 'UTC')."\r\n";
		$ical .= 'DTEND:'.date_convert_timezone(($r['enddatum'].' '.$r['endzeit']), 'UTC')."\r\n";
	}
	$ical .= "SUMMARY:".utf8_encode($r["item_name"].($r["zweck"] ? (": ".$r["zweck"]) : "") )."\r\n";
	$desc = '';
	if($_SESSION["ses_username"] != "ko_guest") {
		$desc .= $r["name"].($r["email"]?", ".$r["email"]:"").($r["telefon"]?", ".$r["telefon"]:"")."\r\n";
		$desc .= $r["comments"]."\r\n";
	}
	if($desc) $ical .= "DESCRIPTION:".utf8_encode($desc)."\r\n";
	$ical .= "END:VEVENT\r\n";
}
$ical .= "END:VCALENDAR\r\n";


//Output
if (isset($_SERVER["HTTP_USER_AGENT"]) && strpos($_SERVER["HTTP_USER_AGENT"], "MSIE")) {
	// IE cannot download from sessions without a cache
	header("Cache-Control: public");
	// q316431 - Don't set no-cache when over HTTPS
	if (	!isset($_SERVER["HTTPS"]) || $_SERVER["HTTPS"] != "on") {
		header("Pragma: no-cache");
	}
}
else {
	header("Cache-Control: no-cache, must-revalidate");
	header("Pragma: no-cache");
}
header('Content-Type: text/calendar', TRUE);
header('Content-Disposition: attachment; filename="kOOLres.ics"');
header("Content-Length: ".strlen($ical));
print $ical;
?>
